import {
  world
} from "mojang-minecraft"
import {
  ActionFormData
} from "mojang-minecraft-ui"

const poderesVP = ['fly', 'rage', 'blooddrinker', 'fogremoval', 'sworddex', 'icetouch', 'nightvision', 'servantsbat', 'poucasede', 'waterproof', 'defencive', 'regeneration', 'absorption', 'sunresistence', 'acrobata', 'indetectavel', 'teleport', 'invisibilidade']
const poderesLB = ['rage', 'onehit', 'fogremoval', 'sworddex', 'sangramento', 'nightvision', 'servantswolf', 'poucafome', 'waterproof', 'defencive', 'regeneration', 'absorption', 'suntransform', 'acrobata', 'indetectavel', 'esquiva', 'invisibilidade']

//FUNCTIONS DE CODIGO
function getRandom(max) {
  const nunbRandow = Math.floor(Math.random() * max + 1)
  return nunbRandow
}

function startVPTransformer(player) {
  player.runCommand('function transVP')
}

function startLBTransformer(player) {
  player.runCommand('function transLB')
}



function UseSkill(player, poderes, tipo) {
  const dlg_UseSkill = new ActionFormData();
  const res_UseSkill = [];
  dlg_UseSkill.button('NoSkill',
    'textures/ui/skill0.png');
  res_UseSkill.push('NoSkill');
  if (tipo == "vampiro") {
    poderes.forEach(poder => {
      if (poder == 'nightvision' || poder == 'sunresistence' || poder == 'fogremoval' || poder == 'waterproof' || poder == 'indetectavel' || poder == 'acrobata') {} else {
        if (player.hasTag(poder) == true) {
          dlg_UseSkill.button('gui.button.UseSkill_' + poder, 'textures/ui/skill_' + poder + '.png');
          res_UseSkill.push(poder);
        }
      }
    });
    dlg_UseSkill.show(player).then(result => {
      player.runCommand('function resetEmUso');
      player.runCommand('tag @s add emuso_' + res_UseSkill[result.selection]);
      if (res_UseSkill[result.selection] == 'fly') {
        player.runCommand('gamerule sendCommandFeedback false');
        player.runCommand('ability @s mayfly true');
        player.runCommand('gamerule sendCommandFeedback true');
      } else if (res_UseSkill[result.selection] == 'teleport') {
        player.runCommand('replaceitem entity @s slot.weapon.mainhand 0 add:skill_teleport 1 0 {"item_lock":{"mode":"lock_in_inventory"},"keep_on_death":{}}')
      } else if (res_UseSkill[result.selection] == 'servantsbat') {
        player.runCommand('summon bat')
        player.runCommand('summon bat')
        player.runCommand('summon bat')
        player.runCommand('execute as @a[type=!minecraft:player,rm=1] run scoreboard players add '+ player.name +' sangue 1000')
        player.runCommand('execute as @a[type=!minecraft:player,rm=1] run particle minecraft:critical_hit_emitter ~~~')
      }
    })
  } else if (tipo == "lobisomem") {
    poderes.forEach(poder => {
      if (poder == "poucafome" || poder == 'nightvision' || poder == 'suntransform' || poder == 'fogremoval' || poder == 'waterproof' || poder == 'indetectavel' || poder == 'acrobata') {} else {
        if (player.hasTag(poder) == true) {
          dlg_UseSkill.button('gui.button.UseSkill_' + poder, 'textures/ui/skill_' + poder + '.png');
          res_UseSkill.push(poder);
        }
      }
    });
    dlg_UseSkill.show(player).then(result => {
      player.runCommand('function resetEmUso');
      player.runCommand('tag @s add emuso_' + res_UseSkill[result.selection]);
      if (res_UseSkill[result.selection] == 'suntransform') {
        player.runCommand('event entity @s lobisomem_skin');
      }
    })
  }
}

function NewSkillUnlock(player, poderes, tipo) {
  const dlg_NewSkillUnlock = new ActionFormData()
  const res_NewSkillUnlock = []
  if (tipo == "vampiro") {
    poderes.forEach(poder => {
      if (player.hasTag(poder) == false) {
        dlg_NewSkillUnlock.button('gui.button.UnlockSkill_' + poder, 'textures/ui/skill_' + poder + '.png');
        res_NewSkillUnlock.push(poder);
      }
    });
    dlg_NewSkillUnlock.show(player).then(result => {
      if (res_NewSkillUnlock[result.selection] == 'nightvision' || res_NewSkillUnlock[result.selection] == 'fly' || res_NewSkillUnlock[result.selection] == 'absorption') {
        player.runCommand('tag @s[lm=5] add ' + res_NewSkillUnlock[result.selection]);
        player.runCommand('xp -5L @s[lm=5]');
      } else if (res_NewSkillUnlock[result.selection] == 'rage' || res_NewSkillUnlock[result.selection] == 'servantsbat' || res_NewSkillUnlock[result.selection] == 'sunresistence') {
        player.runCommand('tag @s[lm=15] add ' + res_NewSkillUnlock[result.selection]);
        player.runCommand('xp -15L @s[lm=15]');
      } else if (res_NewSkillUnlock[result.selection] == 'blooddrinker' || res_NewSkillUnlock[result.selection] == 'poucasede' || res_NewSkillUnlock[result.selection] == 'acrobata') {
        player.runCommand('tag @s[lm=20] add ' + res_NewSkillUnlock[result.selection]);
        player.runCommand('xp -20L @s[lm=20]');
      } else if (res_NewSkillUnlock[result.selection] == 'fogremoval' || res_NewSkillUnlock[result.selection] == 'waterproof' || res_NewSkillUnlock[result.selection] == 'indetectavel') {
        player.runCommand('tag @s[lm=10] add ' + res_NewSkillUnlock[result.selection]);
        player.runCommand('xp -10L @s[lm=10]');
      } else if (res_NewSkillUnlock[result.selection] == 'sworddex' || res_NewSkillUnlock[result.selection] == 'defencive' || res_NewSkillUnlock[result.selection] == 'teleport') {
        player.runCommand('tag @s[lm=30] add ' + res_NewSkillUnlock[result.selection]);
        player.runCommand('xp -30L @s[lm=30]');
      } else if (res_NewSkillUnlock[result.selection] == 'icetouch' || res_NewSkillUnlock[result.selection] == 'regeneration' || res_NewSkillUnlock[result.selection] == 'invisibilidade') {
        player.runCommand('tag @s[lm=40] add ' + res_NewSkillUnlock[result.selection]);
        player.runCommand('xp -40L @s[lm=40]');
      }
    })
  } else if (tipo == "lobisomem") {
    poderes.forEach(poder => {
      if (player.hasTag(poder) == false) {
        dlg_NewSkillUnlock.button('gui.button.UnlockSkill_' + poder, 'textures/ui/skill_' + poder + '.png');
        res_NewSkillUnlock.push(poder);
      }
    });
    dlg_NewSkillUnlock.show(player).then(result => {
      if (res_NewSkillUnlock[result.selection] == 'nightvision' || res_NewSkillUnlock[result.selection] == 'absorption') {
        player.runCommand('tag @s[lm=5] add ' + res_NewSkillUnlock[result.selection]);
        player.runCommand('xp -5L @s[lm=5]');
      } else if (res_NewSkillUnlock[result.selection] == 'rage' || res_NewSkillUnlock[result.selection] == 'servantswolf' || res_NewSkillUnlock[result.selection] == 'suntransform') {
        player.runCommand('tag @s[lm=15] add ' + res_NewSkillUnlock[result.selection]);
        player.runCommand('xp -15L @s[lm=15]');
      } else if (res_NewSkillUnlock[result.selection] == 'onehit' || res_NewSkillUnlock[result.selection] == 'poucafome' || res_NewSkillUnlock[result.selection] == 'acrobata') {
        player.runCommand('tag @s[lm=20] add ' + res_NewSkillUnlock[result.selection]);
        player.runCommand('xp -20L @s[lm=20]');
      } else if (res_NewSkillUnlock[result.selection] == 'fogremoval' || res_NewSkillUnlock[result.selection] == 'waterproof' || res_NewSkillUnlock[result.selection] == 'indetectavel') {
        player.runCommand('tag @s[lm=10] add ' + res_NewSkillUnlock[result.selection]);
        player.runCommand('xp -10L @s[lm=10]');
      } else if (res_NewSkillUnlock[result.selection] == 'sworddex' || res_NewSkillUnlock[result.selection] == 'defencive' || res_NewSkillUnlock[result.selection] == 'esquiva') {
        player.runCommand('tag @s[lm=30] add ' + res_NewSkillUnlock[result.selection]);
        player.runCommand('xp -30L @s[lm=30]');
      } else if (res_NewSkillUnlock[result.selection] == 'sangramento' || res_NewSkillUnlock[result.selection] == 'regeneration' || res_NewSkillUnlock[result.selection] == 'invisibilidade') {
        player.runCommand('tag @s[lm=40] add ' + res_NewSkillUnlock[result.selection]);
        player.runCommand('xp -40L @s[lm=40]');
      }
    })
  }

}




//CALL DE DIÁLOGOS
world.events.entityHurt.subscribe(eventData => {
  if (eventData.hurtEntity.id == "minecraft:player" && eventData.cause == "anvil" && eventData.damage == 1) {
    const player = eventData.hurtEntity
    if (player.hasTag('vampiro') == true) {
      NewSkillUnlock(player, poderesVP, "vampiro");
    } else if (player.hasTag('lobisomem') == true) {
      NewSkillUnlock(player, poderesLB, "lobisomem");
    }
  } else if (eventData.hurtEntity.id == "minecraft:player" && eventData.cause == "anvil" && eventData.damage == 0) {
    const player = eventData.hurtEntity
    if (player.hasTag('vampiro') == true) {
      UseSkill(player, poderesVP, 'vampiro');
    } else if (player.hasTag('lobisomem') == true) {
      UseSkill(player, poderesLB, 'lobisomem');
    }
  } else if (eventData.damagingEntity.hasTag('emuso_icetouch')) {
    eventData.hurtEntity.runCommand('effect @s slowness 2 10 true');

  }
})